/**
***     SFHTMLViewerApp.cpp
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#include "SFHTMLViewerApp.hpp"

// u[g [_
SFCApplet::FactorySPP SFCApplet::Boot(AEECLSID id, SFXAnsiStringPtr license)
{
    *license = "heap://";

    return (id == AEECLSID_SFHTMLVIEWERAPP) ? (&SFHTMLViewerApp::Factory) : (null);
}

// t@Ng֐
SFCInvokerPtr SFHTMLViewerApp::Factory(Void)
{
    return ::new SFHTMLViewerApp;
}

// RXgN^
SFHTMLViewerApp::SFHTMLViewerApp(Void) static_throws
{
    RegisterHandler(SREVT_RESPONDER_RENDER, SRP16_RENDER_CONTENT, HANDLER_BEFORE, HANDLER_FUNCTION(OnRenderContent));
    RegisterHandler(SFEVT_KEY, HANDLER_AFTER, HANDLER_FUNCTION(OnKey));
    return;
}

// fXgN^
SFHTMLViewerApp::~SFHTMLViewerApp(Void)
{
    return;
}

// `nh
HANDLER_IMPLEMENT_VOIDRENDER(SFHTMLViewerApp, OnRenderContent, graphics)
{
    static SFXRGBColor::AtomRecConst white = {0x00, 0xFF, 0xFF, 0xFF};
    static SFXRGBColor::AtomRecConst black = {0x00, 0x00, 0x00, 0x00};

    graphics->FillRectangle(GetContentWorld(), white);
    graphics->DrawText("Push Select Key", GetContentWorld(), black);
    return;
}

// L[ nh
HANDLER_IMPLEMENT_BOOLEVENT(SFHTMLViewerApp, OnKey, event)
{
    switch (event.GetP16()) {
        case AVK_SELECT:
            ::new MyWindow(this);
            return true;
    }
    return false;
}

// RXgN^iEBhEɎsj
MyWindow::MyWindow(SFRApplicationPtr app)
    : SFRTitleWindow(app, app->GetContentWorld(), "SFHTMLViewerApp") static_throws
{
    SFXAnsiString buffer(
        "SFHTMLViewerApp<br /><br /><br />"
        "<a href=\"http://www.s-cradle.com/example/tabbrowser/\">Access to Sample Page</a><br /><br />"
        "<img src=\"http://www.s-cradle.com/images/SC_logo_3d.jpg\" width=\"92\" height=\"97\" alt=\"SC LOGO\" />"
    );

    SFRToolbox::RegisterManipulateHandler(this);
    RegisterHandler(SFEVT_KEY, AVK_CLR, HANDLER_AFTER, HANDLER_FUNCTION(OnClearKey));

    SFXRectangle rect(GetContentWorld());

    // uEURg[\tB
    SFRBrowserControlPtr browser(::new SFRBrowserControl(this, rect));
    browser->Load(buffer);
    return;
}

// fXgN^iEBhEjɎsj
MyWindow::~MyWindow(Void)
{
    return;
}

// NAL[ nh
HANDLER_IMPLEMENT_BOOLVOID(MyWindow, OnClearKey)
{
    // EBhE̔j ()
    return Invoke(SFXEvent(SREVT_RESPONDER_TERMINATE, SRP16_TERMINATE_INVOKE, true));
}
