/**
***     SFHTMLViewerApp.hpp
***
***     ̃\[XR[h́AG[XgbvTXyhȂǂ̏Ă܂B
***     Copyright (C) 2006 SophiaCradle Incorporated.
***     All rights reserved.
**/

#ifndef __SFHTMLVIEWERAPP_HPP
#define __SFHTMLVIEWERAPP_HPP

#include <SophiaFramework.hpp>
#include "SFHTMLViewerApp.bid"

SFMTYPEDEFCLASS(SFHTMLViewerApp)
class SFHTMLViewerApp : public SFRApplication {
    SFMSEALCOPY(SFHTMLViewerApp)
    public:
        static SFCInvokerPtr Factory(Void);
    private:
        explicit SFHTMLViewerApp(Void) static_throws;
        virtual ~SFHTMLViewerApp(Void);
        HANDLER_DECLARE_VOIDRENDER(OnRenderContent)
        HANDLER_DECLARE_BOOLEVENT(OnKey)
};

SFMTYPEDEFCLASS(MyWindow)
class MyWindow : public SFRTitleWindow {
    SFMSEALCOPY(MyWindow)
    public:
        explicit MyWindow(SFRApplicationPtr app) static_throws;
        virtual ~MyWindow(Void);
        HANDLER_DECLARE_BOOLVOID(OnClearKey)
};

#endif // __SFHTMLVIEWERAPP_HPP //
